尝试自学ruby - 我正在研究Ruby中的Project Euler问题14。
n = 1000000
array = Array.new(n,0)
#array[x] will store the number of steps to get to one if a solution has been found and 0 otherwise. x will equal the starting number. array[0] will be nonsensical for these purposes
i = n-1#We will start at array[n-1] and work down to 1
while i > 1
if array[i] == 0
numstep = 0 #numstep will hold the number of loops that j makes until it gets to 1 or a number that has already been solved
j = i
while j > 1 && (array[j] == 0 || array[j] == nil)
case j%2
when 1 # j is odd
j = 3*j + 1
when 0 # j is even
j = j/2
end
numstep += 1
end
stop = array[j] #if j has been solved, array[j] is the number of steps to j = 1. If j = 1, array[j] = 0
j = i
counter = 0
while j > 1 && (array[j] == 0 || array[j] == nil)
if j < n
array[j] = numstep + stop - counter #numstep + stop should equal the solution to the ith number, to get the jth number we subtract counter
end
case j%2
when 1 #j is odd
j = 3*j+1
when 0 #j is even
j = j/2
end
counter += 1
end
end
i = i-1
end
puts("The longest Collatz sequence starting below #{n} starts at #{array.each_with_index.max[1]} and is #{array.max} numbers long")
此代码适用于n = 100000及以下,但当我达到n = 1000000时,它运行一会儿(直到j = 999167 * 3 + 1 = 2997502)。当它尝试访问数组的第2997502个索引时,它会抛出错误
in '[]': bignum too big to convert into 'long' (RangeError)
第27行(这是while语句:
while j > 1 && (array[j] == 0 || array[j] == nil)
如何才能避免错误?检查数组是否为零可以节省代码效率,因为它允许您不重新计算已经完成的操作,但是如果我删除了and语句,它会运行并给出正确的答案。我非常确定问题是数组的索引不能是一个bignum,但也许有一种方法来声明我的数组,它可以是?我不太关心答案本身;我实际上已经在C#中解决了这个问题 - 只是想学习ruby,所以我想知道为什么我的代码会这样做(如果我错误的原因)以及如何修复它。
答案 0 :(得分:1)
上面的代码对我来说很愉快,因为任何输入都会在可接受的时间内产生输出。我相信这是因为您可能会遇到32位拱形或类似问题。无论如何,所述问题的解决方案很简单(除非你的内存不足,这是另一个可能的故障。)
数组索引是有限的,因为你得到的错误是如下。很酷,让我们使用哈希吧!
n = 1000000
array = Hash.new(0)
#array[x] will store the number of steps to get to one if a solution has been found and 0 otherwise. x will equal the starting number. arr
i = n-1#We will start at array[n-1] and work down to 1
while i > 1
if array[i].zero?
numstep = 0 #numstep will hold the number of loops that j makes until it gets to 1 or a number that has already been solved
j = i
while j > 1 && array[j].zero?
case j%2
when 1 # j is odd
j = 3*j + 1
when 0 # j is even
j = j/2
end
numstep += 1
end
stop = array[j] #if j has been solved, array[j] is the number of steps to j = 1. If j = 1, array[j] = 0
j = i
counter = 0
while j > 1 && array[j].zero?
if j < n
array[j] = numstep + stop - counter #numstep + stop should equal the solution to the ith number, to get the jth number we
end
case j%2
when 1 #j is odd
j = 3*j+1
when 0 #j is even
j = j/2
end
counter += 1
end
end
i = i-1
end
puts("Longest Collatz below #{n} @#{array.sort_by(&:first).map(&:last).each_with_index.max[1]} is #{arr
请注意,由于我将哈希值与初始值设定项一起使用,array[i]
不能成为nil
,这就是为什么只对零值进行检查的原因。